> For the complete documentation index, see [llms.txt](https://developer.vario-software.de/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://developer.vario-software.de/api-reference/documents.md).

# Documents

Manage documents in the VARIO Cloud DMS via API, including metadata, shares, file uploads, revisions, downloads, deletion states and document references.

Resource managing the Documents in our DMS(Shelf)

## GET /dms/resources/{id}

> Find an existing Resource by identifier

```json
{"openapi":"3.1.0","info":{"title":"OpenAPI definition","version":"2026.42.0"},"tags":[{"name":"Documents","description":"Resource managing the Documents in our DMS(Shelf)"}],"servers":[{"url":"api.example.com"}],"paths":{"/dms/resources/{id}":{"get":{"tags":["Documents"],"summary":"Find an existing Resource by identifier","operationId":"getById_83","parameters":[{"name":"id","in":"path","description":"an identifier","required":true,"schema":{"type":"integer","format":"int64"}}],"responses":{"200":{"description":"successful operation","content":{"application/json":{"schema":{"$ref":"#/components/schemas/dms-shelf-ShelfDocument"}}}},"404":{"description":"Resource with given ID was not found","content":{"application/json":{"schema":{"$ref":"#/components/schemas/core-error-ApiError"}}}}}}}},"components":{"schemas":{"dms-shelf-ShelfDocument":{"properties":{"version":{"type":"string","description":"Version Identifier for this Object (for PUT)"},"info":{"$ref":"#/components/schemas/core-api-MetaInfo"},"id":{"type":"string","description":"Unique identifier of the Object"},"file":{"$ref":"#/components/schemas/dms-shelf-ShelfFile"},"shares":{"type":"array","description":"Share information.","items":{"$ref":"#/components/schemas/dms-shelf-ShelfShare"},"readOnly":true},"description":{"type":"string","description":"description of this document"},"entryDate":{"type":"string","format":"date","description":"Date of this Entry/Document"},"plannedRemovalDate":{"type":"string","format":"date","description":"Automatic deletion from.","readOnly":true},"custom":{"$ref":"#/components/schemas/unknownservice-unknownmodule-JsonNode"},"tags":{"type":"array","description":"List of tags","items":{"$ref":"#/components/schemas/common-tag-TagDto"}},"note":{"type":"string","description":"Note."},"externalId":{"type":"string","format":"uuid","description":"External identifier.","readOnly":true},"alias":{"type":"string","description":"Alias"},"type":{"$ref":"#/components/schemas/dms-shelf-ShelfDocumentType"},"state":{"type":"string","description":"Document status.","enum":["DRAFT","FILE_ATTACHED","MISSING"],"readOnly":true},"deletionState":{"type":"string","default":"NOT_YET","description":"Deletion status.","enum":["NOT_YET","PREPARE_DELETE","FILE_DELETED","MANUALLY_RETAIN"],"readOnly":true},"translatableTexts":{"type":"array","description":"Multilingual labels.","items":{"$ref":"#/components/schemas/dms-shelf-ShelfTranslatableText"}}},"required":["entryDate"]},"core-api-MetaInfo":{"description":"MetaInformations for this Object","properties":{"createdAt":{"type":"string","format":"date-time","description":"Created At Timestamp","readOnly":true},"createdFrom":{"type":"string","description":"TenantUser-Identifier of the creator","readOnly":true},"updatedAt":{"type":"string","format":"date-time","description":"Last Updated AT Timestamp","readOnly":true},"updatedFrom":{"type":"string","description":"TenantUser-Identifier of most recent updater","readOnly":true}}},"dms-shelf-ShelfFile":{"description":"file data","properties":{"version":{"type":"string","description":"Version Identifier for this Object (for PUT)"},"info":{"$ref":"#/components/schemas/core-api-MetaInfo"},"id":{"type":"string","description":"Unique identifier of the Object"},"publicFileExtension":{"type":"string","description":"file-extension of this entry","readOnly":true},"publicFileName":{"type":"string","description":"file-name (without extension) of this entry","readOnly":true},"storageHandle":{"type":"string","description":"current reference of this file in our storage ","readOnly":true},"contentType":{"type":"string","description":"detected content type","readOnly":true},"metaDataEntries":{"type":"array","description":"meta data","items":{"$ref":"#/components/schemas/dms-shelf-ShelfFileMetaData"},"readOnly":true},"fileSize":{"type":"integer","format":"int64","description":"fileSize","readOnly":true},"revisionNumber":{"type":"integer","format":"int32","description":"revision number of this file","readOnly":true},"subFiles":{"type":"array","description":"subFiles for this file","items":{"$ref":"#/components/schemas/dms-shelf-SubFileInfo"},"readOnly":true}}},"dms-shelf-ShelfFileMetaData":{"description":"meta data","properties":{"version":{"type":"string","description":"Version Identifier for this Object (for PUT)"},"info":{"$ref":"#/components/schemas/core-api-MetaInfo"},"id":{"type":"string","description":"Unique identifier of the Object"},"metaKey":{"type":"string","description":"Metadata key."},"metaValue":{"type":"string","description":"Metadata value."}},"required":["metaKey"]},"dms-shelf-SubFileInfo":{"description":"subFiles for this file","properties":{"version":{"type":"string","description":"Version Identifier for this Object (for PUT)"},"info":{"$ref":"#/components/schemas/core-api-MetaInfo"},"id":{"type":"string","description":"Unique identifier of the Object"},"name":{"type":"string","description":"fileName"},"parentPath":{"type":"string","description":"Parent-Path"},"fullPath":{"type":"string","description":"Full-Path"},"modifiedAt":{"type":"string","format":"date-time","description":"file last modified"},"contentType":{"type":"string","description":"Content type."},"shelfFile":{"$ref":"#/components/schemas/core-api-ApiObjectReference"}}},"core-api-ApiObjectReference":{"description":"Parent category.","properties":{"id":{"type":"string","description":"Identifier"},"label":{"type":"string","description":"a label","readOnly":true},"description":{"type":"string","description":"a short description","readOnly":true},"active":{"type":"boolean","description":"Active.","readOnly":true}},"required":["id"]},"dms-shelf-ShelfShare":{"description":"Share information.","properties":{"version":{"type":"string","description":"Version Identifier for this Object (for PUT)"},"info":{"$ref":"#/components/schemas/core-api-MetaInfo"},"id":{"type":"string","description":"Unique identifier of the Object"},"publicUrlPath":{"type":"string","description":"URL path segment that gives public access to this resource.","readOnly":true},"publicUrlCreatedAt":{"type":"string","format":"date","description":"When the public resource was created.","readOnly":true},"publicUrlDurationInMinutes":{"type":"integer","format":"int64","description":"For how many minutes this resource path stays accessible (null means unlimited).","minimum":0},"availability":{"type":"string","description":"Determines how often a public URL is available.","enum":["UNLIMITED","ONE_TIME_USE"]},"timesUsed":{"type":"integer","format":"int32","description":"Number of uses.","readOnly":true},"appId":{"type":"string","format":"uuid","description":"App identifier."},"sharedByExternalRef":{"type":"string","description":"External reference to this share."},"revision":{"type":"integer","format":"int32","description":"Revision","readOnly":true},"eTag":{"type":"string","description":"Revision hash.","readOnly":true},"custom":{"$ref":"#/components/schemas/unknownservice-unknownmodule-JsonNode"},"publishState":{"type":"string","description":"Document share publication status.","enum":["SYNCED","PENDING","DRAFT"]},"translatableTexts":{"type":"array","description":"Multilingual labels.","items":{"$ref":"#/components/schemas/dms-shelf-ShelfTranslatableText"}},"etag":{"type":"string"}},"required":["availability"]},"unknownservice-unknownmodule-JsonNode":{"description":"Search dialog.","properties":{"empty":{"type":"boolean"},"array":{"type":"boolean"},"null":{"type":"boolean"},"object":{"type":"boolean"},"float":{"type":"boolean"},"missingNode":{"type":"boolean"},"valueNode":{"type":"boolean"},"container":{"type":"boolean"},"integralNumber":{"type":"boolean"},"binary":{"type":"boolean"},"nodeType":{"type":"string","enum":["ARRAY","BINARY","BOOLEAN","MISSING","NULL","NUMBER","OBJECT","POJO","STRING"]},"string":{"type":"boolean"},"pojo":{"type":"boolean"},"short":{"type":"boolean"},"int":{"type":"boolean"},"long":{"type":"boolean"},"double":{"type":"boolean"},"bigDecimal":{"type":"boolean"},"bigInteger":{"type":"boolean"},"textual":{"type":"boolean","deprecated":true},"boolean":{"type":"boolean"},"floatingPointNumber":{"type":"boolean"},"number":{"type":"boolean"},"embeddedValue":{"type":"boolean"}}},"dms-shelf-ShelfTranslatableText":{"description":"Multilingual labels.","properties":{"version":{"type":"string","description":"Version Identifier for this Object (for PUT)"},"info":{"$ref":"#/components/schemas/core-api-MetaInfo"},"id":{"type":"string","description":"Unique identifier of the Object"},"alternativeText":{"type":"string","description":"Alternative text.","maxLength":2147483647,"minLength":0},"metaTitle":{"type":"string","description":"Meta title.","maxLength":255,"minLength":0},"languageCode":{"type":"string","description":"Language.","minLength":1}},"required":["languageCode"]},"common-tag-TagDto":{"description":"List of tags","properties":{"version":{"type":"string","description":"Version Identifier for this Object (for PUT)"},"info":{"$ref":"#/components/schemas/core-api-MetaInfo"},"id":{"type":"string","description":"Unique identifier of the Object"},"type":{"type":"string","description":"Tag types.","enum":["COMMON","ACCOUNT","PRODUCT","ASSET","DOCUMENT","OPEN_ITEM","CRM_COMMON","CRM_TASK","CRM_DEAL","CRM_PROJECT","DMS_SHELF_DOCUMENT"]},"label":{"type":"string","description":"Tag label."},"color":{"type":"string","description":"Color for displaying the tag."},"editColor":{"type":"string","description":"Color in the management UI."},"searchColor":{"type":"string","description":"Color in the search UI."},"tagGroup":{"$ref":"#/components/schemas/core-api-ApiCreatableReference"}},"required":["label","type"]},"core-api-ApiCreatableReference":{"description":"Relation type","properties":{"id":{"type":"string","description":"Identifier"},"label":{"type":"string","description":"a label"},"description":{"type":"string","description":"a short description","readOnly":true}}},"dms-shelf-ShelfDocumentType":{"description":"Document type.","properties":{"version":{"type":"string","description":"Version Identifier for this Object (for PUT)"},"info":{"$ref":"#/components/schemas/core-api-MetaInfo"},"id":{"type":"string","description":"Unique identifier of the Object"},"key":{"type":"string","description":"unique key of type","readOnly":true},"label":{"type":"string","description":"label of type","minLength":1},"systemPresetting":{"type":"boolean","default":false,"description":"system presetting","readOnly":true},"duration":{"type":"integer","format":"int32","description":"duration of storage (years)"},"revisionStorageRule":{"type":"integer","format":"int32","description":"storage rule for revisions"},"accessLevelRead":{"type":"integer","format":"int32","description":"Access level for reading."},"accessLevelWrite":{"type":"integer","format":"int32","description":"access level for writing"},"accessLevelDelete":{"type":"integer","format":"int32","description":"access level for deleting"},"active":{"type":"boolean","default":true,"description":"Is the document type active?"}},"required":["label"]},"core-error-ApiError":{"properties":{"instance":{"type":"string","description":"the resource that produced the error","readOnly":true},"trackingId":{"type":"string","description":"Internal tracking number for this Error","readOnly":true},"timeOfOccurence":{"type":"string","format":"date-time","description":"Internal timestamp, when this error happened","readOnly":true},"errors":{"$ref":"#/components/schemas/core-error-ApiError.Errors"},"decisions":{"type":"array","description":"all decisions, we need to take care of","items":{"$ref":"#/components/schemas/core-error-ApiErrorDecision"},"readOnly":true,"uniqueItems":true},"httpStatus":{"type":"integer","format":"int32","description":"HTTP-Status code"},"debug-info-url":{"type":"string","format":"uri","description":"optional url to get a more detailed stack trace","readOnly":true}},"required":["decisions","errors","instance","timeOfOccurence","trackingId"]},"core-error-ApiError.Errors":{"description":"all occured errors","properties":{"fieldErrors":{"type":"object","additionalProperties":{"type":"array","description":"One or more validation errors","items":{"$ref":"#/components/schemas/core-error-ApiErrorDetail"},"readOnly":true,"uniqueItems":true},"description":"One or more validation errors","readOnly":true},"services":{"type":"array","description":"One or more generel service errors","items":{"$ref":"#/components/schemas/core-error-ApiErrorDetail"},"readOnly":true,"uniqueItems":true}},"readOnly":true,"required":["fieldErrors","services"]},"core-error-ApiErrorDetail":{"description":"One or more generel service errors","properties":{"message":{"$ref":"#/components/schemas/core-api-LocalizeableMessage"},"property":{"type":"string","description":"property that has a constraint violation  (optional)"}},"readOnly":true},"core-api-LocalizeableMessage":{"description":"localizeable message","properties":{"messageCode":{"type":"string","description":"Internal unique identifier/key for this message"},"messageParameters":{"type":"object","additionalProperties":{"type":"object","description":"list of parameters to fill a formattable message"},"description":"list of parameters to fill a formattable message"},"formattedMessage":{"type":"string","description":"formatted message (default language)"}}},"core-error-ApiErrorDecision":{"description":"all decisions, we need to take care of","properties":{"message":{"$ref":"#/components/schemas/core-api-LocalizeableMessage"},"title":{"$ref":"#/components/schemas/core-api-LocalizeableMessage"},"multipleAnswersAllowed":{"type":"boolean","default":false,"description":"true, if an array of answers is required","readOnly":true},"textInput":{"type":"boolean","default":false,"description":"true, if text input instead of decisions is required","readOnly":true},"options":{"type":"array","description":"possible options for this decision","items":{"$ref":"#/components/schemas/core-error-ApiErrorDecision.DecisionOption"},"readOnly":true},"answerProperty":{"type":"string","description":"property to fill the decision into","readOnly":true},"answerPropertyType":{"type":"string","description":"type of the target property","enum":["FIELD","PARAMETER"],"readOnly":true},"searchDialog":{"$ref":"#/components/schemas/unknownservice-unknownmodule-JsonNode"}},"readOnly":true},"core-error-ApiErrorDecision.DecisionOption":{"description":"possible options for this decision","properties":{"message":{"$ref":"#/components/schemas/core-api-LocalizeableMessage"},"value":{"type":"string","description":"value for this decision","readOnly":true},"defaultOption":{"type":"boolean","default":false,"description":"default option","readOnly":true},"searchDialogs":{"type":"array","description":"Search dialogs to use.","items":{"$ref":"#/components/schemas/core-error-ApiErrorDecision.DecisionOptionSearchDialog"},"readOnly":true}}},"core-error-ApiErrorDecision.DecisionOptionSearchDialog":{"description":"Search dialogs to use.","properties":{"dialog":{"$ref":"#/components/schemas/unknownservice-unknownmodule-JsonNode"},"answerKey":{"type":"string","description":"Key for the search dialog result.","readOnly":true}}}}}}
```

## PUT /dms/resources/{id}

> Update existing Resource&#x20;

```json
{"openapi":"3.1.0","info":{"title":"OpenAPI definition","version":"2026.42.0"},"tags":[{"name":"Documents","description":"Resource managing the Documents in our DMS(Shelf)"}],"servers":[{"url":"api.example.com"}],"paths":{"/dms/resources/{id}":{"put":{"tags":["Documents"],"summary":"Update existing Resource ","operationId":"update_86","parameters":[{"name":"id","in":"path","description":"an identifier","required":true,"schema":{"type":"integer","format":"int64"}}],"requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/dms-shelf-ShelfDocument"}}},"required":true},"responses":{"200":{"description":"successful operation","content":{"application/json":{"schema":{"$ref":"#/components/schemas/dms-shelf-ShelfDocument"}}}},"404":{"description":"Resource was not found","content":{"application/json":{"schema":{"$ref":"#/components/schemas/core-error-ApiError"}}}},"422":{"description":"Resource was not valid to process","content":{"application/json":{"schema":{"$ref":"#/components/schemas/core-error-ApiError"}}}}}}}},"components":{"schemas":{"dms-shelf-ShelfDocument":{"properties":{"version":{"type":"string","description":"Version Identifier for this Object (for PUT)"},"info":{"$ref":"#/components/schemas/core-api-MetaInfo"},"id":{"type":"string","description":"Unique identifier of the Object"},"file":{"$ref":"#/components/schemas/dms-shelf-ShelfFile"},"shares":{"type":"array","description":"Share information.","items":{"$ref":"#/components/schemas/dms-shelf-ShelfShare"},"readOnly":true},"description":{"type":"string","description":"description of this document"},"entryDate":{"type":"string","format":"date","description":"Date of this Entry/Document"},"plannedRemovalDate":{"type":"string","format":"date","description":"Automatic deletion from.","readOnly":true},"custom":{"$ref":"#/components/schemas/unknownservice-unknownmodule-JsonNode"},"tags":{"type":"array","description":"List of tags","items":{"$ref":"#/components/schemas/common-tag-TagDto"}},"note":{"type":"string","description":"Note."},"externalId":{"type":"string","format":"uuid","description":"External identifier.","readOnly":true},"alias":{"type":"string","description":"Alias"},"type":{"$ref":"#/components/schemas/dms-shelf-ShelfDocumentType"},"state":{"type":"string","description":"Document status.","enum":["DRAFT","FILE_ATTACHED","MISSING"],"readOnly":true},"deletionState":{"type":"string","default":"NOT_YET","description":"Deletion status.","enum":["NOT_YET","PREPARE_DELETE","FILE_DELETED","MANUALLY_RETAIN"],"readOnly":true},"translatableTexts":{"type":"array","description":"Multilingual labels.","items":{"$ref":"#/components/schemas/dms-shelf-ShelfTranslatableText"}}},"required":["entryDate"]},"core-api-MetaInfo":{"description":"MetaInformations for this Object","properties":{"createdAt":{"type":"string","format":"date-time","description":"Created At Timestamp","readOnly":true},"createdFrom":{"type":"string","description":"TenantUser-Identifier of the creator","readOnly":true},"updatedAt":{"type":"string","format":"date-time","description":"Last Updated AT Timestamp","readOnly":true},"updatedFrom":{"type":"string","description":"TenantUser-Identifier of most recent updater","readOnly":true}}},"dms-shelf-ShelfFile":{"description":"file data","properties":{"version":{"type":"string","description":"Version Identifier for this Object (for PUT)"},"info":{"$ref":"#/components/schemas/core-api-MetaInfo"},"id":{"type":"string","description":"Unique identifier of the Object"},"publicFileExtension":{"type":"string","description":"file-extension of this entry","readOnly":true},"publicFileName":{"type":"string","description":"file-name (without extension) of this entry","readOnly":true},"storageHandle":{"type":"string","description":"current reference of this file in our storage ","readOnly":true},"contentType":{"type":"string","description":"detected content type","readOnly":true},"metaDataEntries":{"type":"array","description":"meta data","items":{"$ref":"#/components/schemas/dms-shelf-ShelfFileMetaData"},"readOnly":true},"fileSize":{"type":"integer","format":"int64","description":"fileSize","readOnly":true},"revisionNumber":{"type":"integer","format":"int32","description":"revision number of this file","readOnly":true},"subFiles":{"type":"array","description":"subFiles for this file","items":{"$ref":"#/components/schemas/dms-shelf-SubFileInfo"},"readOnly":true}}},"dms-shelf-ShelfFileMetaData":{"description":"meta data","properties":{"version":{"type":"string","description":"Version Identifier for this Object (for PUT)"},"info":{"$ref":"#/components/schemas/core-api-MetaInfo"},"id":{"type":"string","description":"Unique identifier of the Object"},"metaKey":{"type":"string","description":"Metadata key."},"metaValue":{"type":"string","description":"Metadata value."}},"required":["metaKey"]},"dms-shelf-SubFileInfo":{"description":"subFiles for this file","properties":{"version":{"type":"string","description":"Version Identifier for this Object (for PUT)"},"info":{"$ref":"#/components/schemas/core-api-MetaInfo"},"id":{"type":"string","description":"Unique identifier of the Object"},"name":{"type":"string","description":"fileName"},"parentPath":{"type":"string","description":"Parent-Path"},"fullPath":{"type":"string","description":"Full-Path"},"modifiedAt":{"type":"string","format":"date-time","description":"file last modified"},"contentType":{"type":"string","description":"Content type."},"shelfFile":{"$ref":"#/components/schemas/core-api-ApiObjectReference"}}},"core-api-ApiObjectReference":{"description":"Parent category.","properties":{"id":{"type":"string","description":"Identifier"},"label":{"type":"string","description":"a label","readOnly":true},"description":{"type":"string","description":"a short description","readOnly":true},"active":{"type":"boolean","description":"Active.","readOnly":true}},"required":["id"]},"dms-shelf-ShelfShare":{"description":"Share information.","properties":{"version":{"type":"string","description":"Version Identifier for this Object (for PUT)"},"info":{"$ref":"#/components/schemas/core-api-MetaInfo"},"id":{"type":"string","description":"Unique identifier of the Object"},"publicUrlPath":{"type":"string","description":"URL path segment that gives public access to this resource.","readOnly":true},"publicUrlCreatedAt":{"type":"string","format":"date","description":"When the public resource was created.","readOnly":true},"publicUrlDurationInMinutes":{"type":"integer","format":"int64","description":"For how many minutes this resource path stays accessible (null means unlimited).","minimum":0},"availability":{"type":"string","description":"Determines how often a public URL is available.","enum":["UNLIMITED","ONE_TIME_USE"]},"timesUsed":{"type":"integer","format":"int32","description":"Number of uses.","readOnly":true},"appId":{"type":"string","format":"uuid","description":"App identifier."},"sharedByExternalRef":{"type":"string","description":"External reference to this share."},"revision":{"type":"integer","format":"int32","description":"Revision","readOnly":true},"eTag":{"type":"string","description":"Revision hash.","readOnly":true},"custom":{"$ref":"#/components/schemas/unknownservice-unknownmodule-JsonNode"},"publishState":{"type":"string","description":"Document share publication status.","enum":["SYNCED","PENDING","DRAFT"]},"translatableTexts":{"type":"array","description":"Multilingual labels.","items":{"$ref":"#/components/schemas/dms-shelf-ShelfTranslatableText"}},"etag":{"type":"string"}},"required":["availability"]},"unknownservice-unknownmodule-JsonNode":{"description":"Search dialog.","properties":{"empty":{"type":"boolean"},"array":{"type":"boolean"},"null":{"type":"boolean"},"object":{"type":"boolean"},"float":{"type":"boolean"},"missingNode":{"type":"boolean"},"valueNode":{"type":"boolean"},"container":{"type":"boolean"},"integralNumber":{"type":"boolean"},"binary":{"type":"boolean"},"nodeType":{"type":"string","enum":["ARRAY","BINARY","BOOLEAN","MISSING","NULL","NUMBER","OBJECT","POJO","STRING"]},"string":{"type":"boolean"},"pojo":{"type":"boolean"},"short":{"type":"boolean"},"int":{"type":"boolean"},"long":{"type":"boolean"},"double":{"type":"boolean"},"bigDecimal":{"type":"boolean"},"bigInteger":{"type":"boolean"},"textual":{"type":"boolean","deprecated":true},"boolean":{"type":"boolean"},"floatingPointNumber":{"type":"boolean"},"number":{"type":"boolean"},"embeddedValue":{"type":"boolean"}}},"dms-shelf-ShelfTranslatableText":{"description":"Multilingual labels.","properties":{"version":{"type":"string","description":"Version Identifier for this Object (for PUT)"},"info":{"$ref":"#/components/schemas/core-api-MetaInfo"},"id":{"type":"string","description":"Unique identifier of the Object"},"alternativeText":{"type":"string","description":"Alternative text.","maxLength":2147483647,"minLength":0},"metaTitle":{"type":"string","description":"Meta title.","maxLength":255,"minLength":0},"languageCode":{"type":"string","description":"Language.","minLength":1}},"required":["languageCode"]},"common-tag-TagDto":{"description":"List of tags","properties":{"version":{"type":"string","description":"Version Identifier for this Object (for PUT)"},"info":{"$ref":"#/components/schemas/core-api-MetaInfo"},"id":{"type":"string","description":"Unique identifier of the Object"},"type":{"type":"string","description":"Tag types.","enum":["COMMON","ACCOUNT","PRODUCT","ASSET","DOCUMENT","OPEN_ITEM","CRM_COMMON","CRM_TASK","CRM_DEAL","CRM_PROJECT","DMS_SHELF_DOCUMENT"]},"label":{"type":"string","description":"Tag label."},"color":{"type":"string","description":"Color for displaying the tag."},"editColor":{"type":"string","description":"Color in the management UI."},"searchColor":{"type":"string","description":"Color in the search UI."},"tagGroup":{"$ref":"#/components/schemas/core-api-ApiCreatableReference"}},"required":["label","type"]},"core-api-ApiCreatableReference":{"description":"Relation type","properties":{"id":{"type":"string","description":"Identifier"},"label":{"type":"string","description":"a label"},"description":{"type":"string","description":"a short description","readOnly":true}}},"dms-shelf-ShelfDocumentType":{"description":"Document type.","properties":{"version":{"type":"string","description":"Version Identifier for this Object (for PUT)"},"info":{"$ref":"#/components/schemas/core-api-MetaInfo"},"id":{"type":"string","description":"Unique identifier of the Object"},"key":{"type":"string","description":"unique key of type","readOnly":true},"label":{"type":"string","description":"label of type","minLength":1},"systemPresetting":{"type":"boolean","default":false,"description":"system presetting","readOnly":true},"duration":{"type":"integer","format":"int32","description":"duration of storage (years)"},"revisionStorageRule":{"type":"integer","format":"int32","description":"storage rule for revisions"},"accessLevelRead":{"type":"integer","format":"int32","description":"Access level for reading."},"accessLevelWrite":{"type":"integer","format":"int32","description":"access level for writing"},"accessLevelDelete":{"type":"integer","format":"int32","description":"access level for deleting"},"active":{"type":"boolean","default":true,"description":"Is the document type active?"}},"required":["label"]},"core-error-ApiError":{"properties":{"instance":{"type":"string","description":"the resource that produced the error","readOnly":true},"trackingId":{"type":"string","description":"Internal tracking number for this Error","readOnly":true},"timeOfOccurence":{"type":"string","format":"date-time","description":"Internal timestamp, when this error happened","readOnly":true},"errors":{"$ref":"#/components/schemas/core-error-ApiError.Errors"},"decisions":{"type":"array","description":"all decisions, we need to take care of","items":{"$ref":"#/components/schemas/core-error-ApiErrorDecision"},"readOnly":true,"uniqueItems":true},"httpStatus":{"type":"integer","format":"int32","description":"HTTP-Status code"},"debug-info-url":{"type":"string","format":"uri","description":"optional url to get a more detailed stack trace","readOnly":true}},"required":["decisions","errors","instance","timeOfOccurence","trackingId"]},"core-error-ApiError.Errors":{"description":"all occured errors","properties":{"fieldErrors":{"type":"object","additionalProperties":{"type":"array","description":"One or more validation errors","items":{"$ref":"#/components/schemas/core-error-ApiErrorDetail"},"readOnly":true,"uniqueItems":true},"description":"One or more validation errors","readOnly":true},"services":{"type":"array","description":"One or more generel service errors","items":{"$ref":"#/components/schemas/core-error-ApiErrorDetail"},"readOnly":true,"uniqueItems":true}},"readOnly":true,"required":["fieldErrors","services"]},"core-error-ApiErrorDetail":{"description":"One or more generel service errors","properties":{"message":{"$ref":"#/components/schemas/core-api-LocalizeableMessage"},"property":{"type":"string","description":"property that has a constraint violation  (optional)"}},"readOnly":true},"core-api-LocalizeableMessage":{"description":"localizeable message","properties":{"messageCode":{"type":"string","description":"Internal unique identifier/key for this message"},"messageParameters":{"type":"object","additionalProperties":{"type":"object","description":"list of parameters to fill a formattable message"},"description":"list of parameters to fill a formattable message"},"formattedMessage":{"type":"string","description":"formatted message (default language)"}}},"core-error-ApiErrorDecision":{"description":"all decisions, we need to take care of","properties":{"message":{"$ref":"#/components/schemas/core-api-LocalizeableMessage"},"title":{"$ref":"#/components/schemas/core-api-LocalizeableMessage"},"multipleAnswersAllowed":{"type":"boolean","default":false,"description":"true, if an array of answers is required","readOnly":true},"textInput":{"type":"boolean","default":false,"description":"true, if text input instead of decisions is required","readOnly":true},"options":{"type":"array","description":"possible options for this decision","items":{"$ref":"#/components/schemas/core-error-ApiErrorDecision.DecisionOption"},"readOnly":true},"answerProperty":{"type":"string","description":"property to fill the decision into","readOnly":true},"answerPropertyType":{"type":"string","description":"type of the target property","enum":["FIELD","PARAMETER"],"readOnly":true},"searchDialog":{"$ref":"#/components/schemas/unknownservice-unknownmodule-JsonNode"}},"readOnly":true},"core-error-ApiErrorDecision.DecisionOption":{"description":"possible options for this decision","properties":{"message":{"$ref":"#/components/schemas/core-api-LocalizeableMessage"},"value":{"type":"string","description":"value for this decision","readOnly":true},"defaultOption":{"type":"boolean","default":false,"description":"default option","readOnly":true},"searchDialogs":{"type":"array","description":"Search dialogs to use.","items":{"$ref":"#/components/schemas/core-error-ApiErrorDecision.DecisionOptionSearchDialog"},"readOnly":true}}},"core-error-ApiErrorDecision.DecisionOptionSearchDialog":{"description":"Search dialogs to use.","properties":{"dialog":{"$ref":"#/components/schemas/unknownservice-unknownmodule-JsonNode"},"answerKey":{"type":"string","description":"Key for the search dialog result.","readOnly":true}}}}}}
```

## GET /dms/resources/{id}/shares/{shareId}

> get ONE existing share

```json
{"openapi":"3.1.0","info":{"title":"OpenAPI definition","version":"2026.42.0"},"tags":[{"name":"Documents","description":"Resource managing the Documents in our DMS(Shelf)"}],"servers":[{"url":"api.example.com"}],"paths":{"/dms/resources/{id}/shares/{shareId}":{"get":{"tags":["Documents"],"summary":"get ONE existing share","operationId":"getShareById","parameters":[{"name":"id","in":"path","description":"an identifier","required":true,"schema":{"type":"integer","format":"int64"}},{"name":"shareId","in":"path","description":"an identifier","required":true,"schema":{"type":"integer","format":"int64"}}],"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"$ref":"#/components/schemas/dms-shelf-ShelfShare"}}}}}}}},"components":{"schemas":{"dms-shelf-ShelfShare":{"description":"Share information.","properties":{"version":{"type":"string","description":"Version Identifier for this Object (for PUT)"},"info":{"$ref":"#/components/schemas/core-api-MetaInfo"},"id":{"type":"string","description":"Unique identifier of the Object"},"publicUrlPath":{"type":"string","description":"URL path segment that gives public access to this resource.","readOnly":true},"publicUrlCreatedAt":{"type":"string","format":"date","description":"When the public resource was created.","readOnly":true},"publicUrlDurationInMinutes":{"type":"integer","format":"int64","description":"For how many minutes this resource path stays accessible (null means unlimited).","minimum":0},"availability":{"type":"string","description":"Determines how often a public URL is available.","enum":["UNLIMITED","ONE_TIME_USE"]},"timesUsed":{"type":"integer","format":"int32","description":"Number of uses.","readOnly":true},"appId":{"type":"string","format":"uuid","description":"App identifier."},"sharedByExternalRef":{"type":"string","description":"External reference to this share."},"revision":{"type":"integer","format":"int32","description":"Revision","readOnly":true},"eTag":{"type":"string","description":"Revision hash.","readOnly":true},"custom":{"$ref":"#/components/schemas/unknownservice-unknownmodule-JsonNode"},"publishState":{"type":"string","description":"Document share publication status.","enum":["SYNCED","PENDING","DRAFT"]},"translatableTexts":{"type":"array","description":"Multilingual labels.","items":{"$ref":"#/components/schemas/dms-shelf-ShelfTranslatableText"}},"etag":{"type":"string"}},"required":["availability"]},"core-api-MetaInfo":{"description":"MetaInformations for this Object","properties":{"createdAt":{"type":"string","format":"date-time","description":"Created At Timestamp","readOnly":true},"createdFrom":{"type":"string","description":"TenantUser-Identifier of the creator","readOnly":true},"updatedAt":{"type":"string","format":"date-time","description":"Last Updated AT Timestamp","readOnly":true},"updatedFrom":{"type":"string","description":"TenantUser-Identifier of most recent updater","readOnly":true}}},"unknownservice-unknownmodule-JsonNode":{"description":"Search dialog.","properties":{"empty":{"type":"boolean"},"array":{"type":"boolean"},"null":{"type":"boolean"},"object":{"type":"boolean"},"float":{"type":"boolean"},"missingNode":{"type":"boolean"},"valueNode":{"type":"boolean"},"container":{"type":"boolean"},"integralNumber":{"type":"boolean"},"binary":{"type":"boolean"},"nodeType":{"type":"string","enum":["ARRAY","BINARY","BOOLEAN","MISSING","NULL","NUMBER","OBJECT","POJO","STRING"]},"string":{"type":"boolean"},"pojo":{"type":"boolean"},"short":{"type":"boolean"},"int":{"type":"boolean"},"long":{"type":"boolean"},"double":{"type":"boolean"},"bigDecimal":{"type":"boolean"},"bigInteger":{"type":"boolean"},"textual":{"type":"boolean","deprecated":true},"boolean":{"type":"boolean"},"floatingPointNumber":{"type":"boolean"},"number":{"type":"boolean"},"embeddedValue":{"type":"boolean"}}},"dms-shelf-ShelfTranslatableText":{"description":"Multilingual labels.","properties":{"version":{"type":"string","description":"Version Identifier for this Object (for PUT)"},"info":{"$ref":"#/components/schemas/core-api-MetaInfo"},"id":{"type":"string","description":"Unique identifier of the Object"},"alternativeText":{"type":"string","description":"Alternative text.","maxLength":2147483647,"minLength":0},"metaTitle":{"type":"string","description":"Meta title.","maxLength":255,"minLength":0},"languageCode":{"type":"string","description":"Language.","minLength":1}},"required":["languageCode"]}}}}
```

## PUT /dms/resources/{id}/shares/{shareId}

> Update existing Share

```json
{"openapi":"3.1.0","info":{"title":"OpenAPI definition","version":"2026.42.0"},"tags":[{"name":"Documents","description":"Resource managing the Documents in our DMS(Shelf)"}],"servers":[{"url":"api.example.com"}],"paths":{"/dms/resources/{id}/shares/{shareId}":{"put":{"tags":["Documents"],"summary":"Update existing Share","operationId":"updateShare","parameters":[{"name":"id","in":"path","description":"an identifier","required":true,"schema":{"type":"integer","format":"int64"}},{"name":"shareId","in":"path","required":true,"schema":{"type":"integer","format":"int64"}}],"requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/dms-shelf-ShelfShare"}}},"required":true},"responses":{"200":{"description":"successful operation","content":{"application/json":{"schema":{"$ref":"#/components/schemas/dms-shelf-ShelfShare"}}}},"422":{"description":"Resource was not valid to process","content":{"application/json":{"schema":{"$ref":"#/components/schemas/core-error-ApiError"}}}}}}}},"components":{"schemas":{"dms-shelf-ShelfShare":{"description":"Share information.","properties":{"version":{"type":"string","description":"Version Identifier for this Object (for PUT)"},"info":{"$ref":"#/components/schemas/core-api-MetaInfo"},"id":{"type":"string","description":"Unique identifier of the Object"},"publicUrlPath":{"type":"string","description":"URL path segment that gives public access to this resource.","readOnly":true},"publicUrlCreatedAt":{"type":"string","format":"date","description":"When the public resource was created.","readOnly":true},"publicUrlDurationInMinutes":{"type":"integer","format":"int64","description":"For how many minutes this resource path stays accessible (null means unlimited).","minimum":0},"availability":{"type":"string","description":"Determines how often a public URL is available.","enum":["UNLIMITED","ONE_TIME_USE"]},"timesUsed":{"type":"integer","format":"int32","description":"Number of uses.","readOnly":true},"appId":{"type":"string","format":"uuid","description":"App identifier."},"sharedByExternalRef":{"type":"string","description":"External reference to this share."},"revision":{"type":"integer","format":"int32","description":"Revision","readOnly":true},"eTag":{"type":"string","description":"Revision hash.","readOnly":true},"custom":{"$ref":"#/components/schemas/unknownservice-unknownmodule-JsonNode"},"publishState":{"type":"string","description":"Document share publication status.","enum":["SYNCED","PENDING","DRAFT"]},"translatableTexts":{"type":"array","description":"Multilingual labels.","items":{"$ref":"#/components/schemas/dms-shelf-ShelfTranslatableText"}},"etag":{"type":"string"}},"required":["availability"]},"core-api-MetaInfo":{"description":"MetaInformations for this Object","properties":{"createdAt":{"type":"string","format":"date-time","description":"Created At Timestamp","readOnly":true},"createdFrom":{"type":"string","description":"TenantUser-Identifier of the creator","readOnly":true},"updatedAt":{"type":"string","format":"date-time","description":"Last Updated AT Timestamp","readOnly":true},"updatedFrom":{"type":"string","description":"TenantUser-Identifier of most recent updater","readOnly":true}}},"unknownservice-unknownmodule-JsonNode":{"description":"Search dialog.","properties":{"empty":{"type":"boolean"},"array":{"type":"boolean"},"null":{"type":"boolean"},"object":{"type":"boolean"},"float":{"type":"boolean"},"missingNode":{"type":"boolean"},"valueNode":{"type":"boolean"},"container":{"type":"boolean"},"integralNumber":{"type":"boolean"},"binary":{"type":"boolean"},"nodeType":{"type":"string","enum":["ARRAY","BINARY","BOOLEAN","MISSING","NULL","NUMBER","OBJECT","POJO","STRING"]},"string":{"type":"boolean"},"pojo":{"type":"boolean"},"short":{"type":"boolean"},"int":{"type":"boolean"},"long":{"type":"boolean"},"double":{"type":"boolean"},"bigDecimal":{"type":"boolean"},"bigInteger":{"type":"boolean"},"textual":{"type":"boolean","deprecated":true},"boolean":{"type":"boolean"},"floatingPointNumber":{"type":"boolean"},"number":{"type":"boolean"},"embeddedValue":{"type":"boolean"}}},"dms-shelf-ShelfTranslatableText":{"description":"Multilingual labels.","properties":{"version":{"type":"string","description":"Version Identifier for this Object (for PUT)"},"info":{"$ref":"#/components/schemas/core-api-MetaInfo"},"id":{"type":"string","description":"Unique identifier of the Object"},"alternativeText":{"type":"string","description":"Alternative text.","maxLength":2147483647,"minLength":0},"metaTitle":{"type":"string","description":"Meta title.","maxLength":255,"minLength":0},"languageCode":{"type":"string","description":"Language.","minLength":1}},"required":["languageCode"]},"core-error-ApiError":{"properties":{"instance":{"type":"string","description":"the resource that produced the error","readOnly":true},"trackingId":{"type":"string","description":"Internal tracking number for this Error","readOnly":true},"timeOfOccurence":{"type":"string","format":"date-time","description":"Internal timestamp, when this error happened","readOnly":true},"errors":{"$ref":"#/components/schemas/core-error-ApiError.Errors"},"decisions":{"type":"array","description":"all decisions, we need to take care of","items":{"$ref":"#/components/schemas/core-error-ApiErrorDecision"},"readOnly":true,"uniqueItems":true},"httpStatus":{"type":"integer","format":"int32","description":"HTTP-Status code"},"debug-info-url":{"type":"string","format":"uri","description":"optional url to get a more detailed stack trace","readOnly":true}},"required":["decisions","errors","instance","timeOfOccurence","trackingId"]},"core-error-ApiError.Errors":{"description":"all occured errors","properties":{"fieldErrors":{"type":"object","additionalProperties":{"type":"array","description":"One or more validation errors","items":{"$ref":"#/components/schemas/core-error-ApiErrorDetail"},"readOnly":true,"uniqueItems":true},"description":"One or more validation errors","readOnly":true},"services":{"type":"array","description":"One or more generel service errors","items":{"$ref":"#/components/schemas/core-error-ApiErrorDetail"},"readOnly":true,"uniqueItems":true}},"readOnly":true,"required":["fieldErrors","services"]},"core-error-ApiErrorDetail":{"description":"One or more generel service errors","properties":{"message":{"$ref":"#/components/schemas/core-api-LocalizeableMessage"},"property":{"type":"string","description":"property that has a constraint violation  (optional)"}},"readOnly":true},"core-api-LocalizeableMessage":{"description":"localizeable message","properties":{"messageCode":{"type":"string","description":"Internal unique identifier/key for this message"},"messageParameters":{"type":"object","additionalProperties":{"type":"object","description":"list of parameters to fill a formattable message"},"description":"list of parameters to fill a formattable message"},"formattedMessage":{"type":"string","description":"formatted message (default language)"}}},"core-error-ApiErrorDecision":{"description":"all decisions, we need to take care of","properties":{"message":{"$ref":"#/components/schemas/core-api-LocalizeableMessage"},"title":{"$ref":"#/components/schemas/core-api-LocalizeableMessage"},"multipleAnswersAllowed":{"type":"boolean","default":false,"description":"true, if an array of answers is required","readOnly":true},"textInput":{"type":"boolean","default":false,"description":"true, if text input instead of decisions is required","readOnly":true},"options":{"type":"array","description":"possible options for this decision","items":{"$ref":"#/components/schemas/core-error-ApiErrorDecision.DecisionOption"},"readOnly":true},"answerProperty":{"type":"string","description":"property to fill the decision into","readOnly":true},"answerPropertyType":{"type":"string","description":"type of the target property","enum":["FIELD","PARAMETER"],"readOnly":true},"searchDialog":{"$ref":"#/components/schemas/unknownservice-unknownmodule-JsonNode"}},"readOnly":true},"core-error-ApiErrorDecision.DecisionOption":{"description":"possible options for this decision","properties":{"message":{"$ref":"#/components/schemas/core-api-LocalizeableMessage"},"value":{"type":"string","description":"value for this decision","readOnly":true},"defaultOption":{"type":"boolean","default":false,"description":"default option","readOnly":true},"searchDialogs":{"type":"array","description":"Search dialogs to use.","items":{"$ref":"#/components/schemas/core-error-ApiErrorDecision.DecisionOptionSearchDialog"},"readOnly":true}}},"core-error-ApiErrorDecision.DecisionOptionSearchDialog":{"description":"Search dialogs to use.","properties":{"dialog":{"$ref":"#/components/schemas/unknownservice-unknownmodule-JsonNode"},"answerKey":{"type":"string","description":"Key for the search dialog result.","readOnly":true}}}}}}
```

## DELETE /dms/resources/{id}/shares/{shareId}

> delete an existing share

```json
{"openapi":"3.1.0","info":{"title":"OpenAPI definition","version":"2026.42.0"},"tags":[{"name":"Documents","description":"Resource managing the Documents in our DMS(Shelf)"}],"servers":[{"url":"api.example.com"}],"paths":{"/dms/resources/{id}/shares/{shareId}":{"delete":{"tags":["Documents"],"summary":"delete an existing share","operationId":"deleteShareById","parameters":[{"name":"id","in":"path","description":"an identifier","required":true,"schema":{"type":"integer","format":"int64"}},{"name":"shareId","in":"path","description":"an identifier","required":true,"schema":{"type":"integer","format":"int64"}}],"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"$ref":"#/components/schemas/core-api-OperationMessage"}}}}}}}},"components":{"schemas":{"core-api-OperationMessage":{"properties":{"context":{"type":"string","description":"message context"},"messageValue":{"type":"string","description":" message"}}}}}}
```

## POST /dms/resources/{id}/file-transfer/{token}/{part}

> Upload or change a file transfer part

```json
{"openapi":"3.1.0","info":{"title":"OpenAPI definition","version":"2026.42.0"},"tags":[{"name":"Documents","description":"Resource managing the Documents in our DMS(Shelf)"}],"servers":[{"url":"api.example.com"}],"paths":{"/dms/resources/{id}/file-transfer/{token}/{part}":{"post":{"tags":["Documents"],"summary":"Upload or change a file transfer part","operationId":"createFileTransferPart","parameters":[{"name":"id","in":"path","description":"an identifier","required":true,"schema":{"type":"integer","format":"int64"}},{"name":"token","in":"path","description":"file-transfer token","required":true,"schema":{"type":"string"}},{"name":"part","in":"path","description":"unique part number","required":true,"schema":{"type":"integer","format":"int64"}}],"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"$ref":"#/components/schemas/dms-shelf-TransferFilePartCreateResponse"}}}}}}}},"components":{"schemas":{"dms-shelf-TransferFilePartCreateResponse":{"description":"Response when an UploadPart is created.","properties":{"uploadUri":{"type":"string","description":"upload-url for the real (tm) upload"}}}}}}
```

## PUT /dms/resources/{id}/file-transfer/{token}/{part}

> Upload or change a file transfer part

```json
{"openapi":"3.1.0","info":{"title":"OpenAPI definition","version":"2026.42.0"},"tags":[{"name":"Documents","description":"Resource managing the Documents in our DMS(Shelf)"}],"servers":[{"url":"api.example.com"}],"paths":{"/dms/resources/{id}/file-transfer/{token}/{part}":{"put":{"tags":["Documents"],"summary":"Upload or change a file transfer part","operationId":"updateFileTransferPart","parameters":[{"name":"id","in":"path","description":"an identifier","required":true,"schema":{"type":"integer","format":"int64"}},{"name":"token","in":"path","description":"file-transfer token","required":true,"schema":{"type":"string"}},{"name":"part","in":"path","description":"unique part number","required":true,"schema":{"type":"integer","format":"int64"}}],"requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/dms-shelf-TransferFilePartUpdateRequest"}}},"required":true},"responses":{"200":{"description":"OK"}}}}},"components":{"schemas":{"dms-shelf-TransferFilePartUpdateRequest":{"description":"Updates a file part upload.","properties":{"uploadEtag":{"type":"string","description":"resulting ETag from UploadPart upload","minLength":1}},"required":["uploadEtag"]}}}}
```

## PUT /dms/resources/{id}/deletion\_state

>

```json
{"openapi":"3.1.0","info":{"title":"OpenAPI definition","version":"2026.42.0"},"tags":[{"name":"Documents","description":"Resource managing the Documents in our DMS(Shelf)"}],"servers":[{"url":"api.example.com"}],"paths":{"/dms/resources/{id}/deletion_state":{"put":{"tags":["Documents"],"operationId":"updateDeletionState","parameters":[{"name":"id","in":"path","required":true,"schema":{"type":"integer","format":"int64"}},{"name":"newDeletionState","in":"query","required":true,"schema":{"type":"string","enum":["NOT_YET","PREPARE_DELETE","MANUALLY_RETAIN"]}}],"responses":{"200":{"description":"OK"}}}}}}
```

## POST /dms/resources

> Create new Resource

```json
{"openapi":"3.1.0","info":{"title":"OpenAPI definition","version":"2026.42.0"},"tags":[{"name":"Documents","description":"Resource managing the Documents in our DMS(Shelf)"}],"servers":[{"url":"api.example.com"}],"paths":{"/dms/resources":{"post":{"tags":["Documents"],"summary":"Create new Resource","operationId":"create_82","requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/dms-shelf-ShelfDocumentPostRequest"}}},"required":true},"responses":{"200":{"description":"successful operation","content":{"application/json":{"schema":{"$ref":"#/components/schemas/dms-shelf-ShelfDocument"}}}},"422":{"description":"Resource was not valid to process","content":{"application/json":{"schema":{"$ref":"#/components/schemas/core-error-ApiError"}}}}}}}},"components":{"schemas":{"dms-shelf-ShelfDocumentPostRequest":{"properties":{"shelfDocument":{"$ref":"#/components/schemas/dms-shelf-ShelfDocument"},"attributions":{"type":"array","description":"References to other elements, e.g. an account, an import run, and so on.","items":{"$ref":"#/components/schemas/dms-shelf-ShelfDocumentAttribution"}},"transformations":{"type":"array","description":"Transformations.","items":{"$ref":"#/components/schemas/dms-shelf-ShelfImageTransformation"}}},"required":["shelfDocument"]},"dms-shelf-ShelfDocument":{"properties":{"version":{"type":"string","description":"Version Identifier for this Object (for PUT)"},"info":{"$ref":"#/components/schemas/core-api-MetaInfo"},"id":{"type":"string","description":"Unique identifier of the Object"},"file":{"$ref":"#/components/schemas/dms-shelf-ShelfFile"},"shares":{"type":"array","description":"Share information.","items":{"$ref":"#/components/schemas/dms-shelf-ShelfShare"},"readOnly":true},"description":{"type":"string","description":"description of this document"},"entryDate":{"type":"string","format":"date","description":"Date of this Entry/Document"},"plannedRemovalDate":{"type":"string","format":"date","description":"Automatic deletion from.","readOnly":true},"custom":{"$ref":"#/components/schemas/unknownservice-unknownmodule-JsonNode"},"tags":{"type":"array","description":"List of tags","items":{"$ref":"#/components/schemas/common-tag-TagDto"}},"note":{"type":"string","description":"Note."},"externalId":{"type":"string","format":"uuid","description":"External identifier.","readOnly":true},"alias":{"type":"string","description":"Alias"},"type":{"$ref":"#/components/schemas/dms-shelf-ShelfDocumentType"},"state":{"type":"string","description":"Document status.","enum":["DRAFT","FILE_ATTACHED","MISSING"],"readOnly":true},"deletionState":{"type":"string","default":"NOT_YET","description":"Deletion status.","enum":["NOT_YET","PREPARE_DELETE","FILE_DELETED","MANUALLY_RETAIN"],"readOnly":true},"translatableTexts":{"type":"array","description":"Multilingual labels.","items":{"$ref":"#/components/schemas/dms-shelf-ShelfTranslatableText"}}},"required":["entryDate"]},"core-api-MetaInfo":{"description":"MetaInformations for this Object","properties":{"createdAt":{"type":"string","format":"date-time","description":"Created At Timestamp","readOnly":true},"createdFrom":{"type":"string","description":"TenantUser-Identifier of the creator","readOnly":true},"updatedAt":{"type":"string","format":"date-time","description":"Last Updated AT Timestamp","readOnly":true},"updatedFrom":{"type":"string","description":"TenantUser-Identifier of most recent updater","readOnly":true}}},"dms-shelf-ShelfFile":{"description":"file data","properties":{"version":{"type":"string","description":"Version Identifier for this Object (for PUT)"},"info":{"$ref":"#/components/schemas/core-api-MetaInfo"},"id":{"type":"string","description":"Unique identifier of the Object"},"publicFileExtension":{"type":"string","description":"file-extension of this entry","readOnly":true},"publicFileName":{"type":"string","description":"file-name (without extension) of this entry","readOnly":true},"storageHandle":{"type":"string","description":"current reference of this file in our storage ","readOnly":true},"contentType":{"type":"string","description":"detected content type","readOnly":true},"metaDataEntries":{"type":"array","description":"meta data","items":{"$ref":"#/components/schemas/dms-shelf-ShelfFileMetaData"},"readOnly":true},"fileSize":{"type":"integer","format":"int64","description":"fileSize","readOnly":true},"revisionNumber":{"type":"integer","format":"int32","description":"revision number of this file","readOnly":true},"subFiles":{"type":"array","description":"subFiles for this file","items":{"$ref":"#/components/schemas/dms-shelf-SubFileInfo"},"readOnly":true}}},"dms-shelf-ShelfFileMetaData":{"description":"meta data","properties":{"version":{"type":"string","description":"Version Identifier for this Object (for PUT)"},"info":{"$ref":"#/components/schemas/core-api-MetaInfo"},"id":{"type":"string","description":"Unique identifier of the Object"},"metaKey":{"type":"string","description":"Metadata key."},"metaValue":{"type":"string","description":"Metadata value."}},"required":["metaKey"]},"dms-shelf-SubFileInfo":{"description":"subFiles for this file","properties":{"version":{"type":"string","description":"Version Identifier for this Object (for PUT)"},"info":{"$ref":"#/components/schemas/core-api-MetaInfo"},"id":{"type":"string","description":"Unique identifier of the Object"},"name":{"type":"string","description":"fileName"},"parentPath":{"type":"string","description":"Parent-Path"},"fullPath":{"type":"string","description":"Full-Path"},"modifiedAt":{"type":"string","format":"date-time","description":"file last modified"},"contentType":{"type":"string","description":"Content type."},"shelfFile":{"$ref":"#/components/schemas/core-api-ApiObjectReference"}}},"core-api-ApiObjectReference":{"description":"Parent category.","properties":{"id":{"type":"string","description":"Identifier"},"label":{"type":"string","description":"a label","readOnly":true},"description":{"type":"string","description":"a short description","readOnly":true},"active":{"type":"boolean","description":"Active.","readOnly":true}},"required":["id"]},"dms-shelf-ShelfShare":{"description":"Share information.","properties":{"version":{"type":"string","description":"Version Identifier for this Object (for PUT)"},"info":{"$ref":"#/components/schemas/core-api-MetaInfo"},"id":{"type":"string","description":"Unique identifier of the Object"},"publicUrlPath":{"type":"string","description":"URL path segment that gives public access to this resource.","readOnly":true},"publicUrlCreatedAt":{"type":"string","format":"date","description":"When the public resource was created.","readOnly":true},"publicUrlDurationInMinutes":{"type":"integer","format":"int64","description":"For how many minutes this resource path stays accessible (null means unlimited).","minimum":0},"availability":{"type":"string","description":"Determines how often a public URL is available.","enum":["UNLIMITED","ONE_TIME_USE"]},"timesUsed":{"type":"integer","format":"int32","description":"Number of uses.","readOnly":true},"appId":{"type":"string","format":"uuid","description":"App identifier."},"sharedByExternalRef":{"type":"string","description":"External reference to this share."},"revision":{"type":"integer","format":"int32","description":"Revision","readOnly":true},"eTag":{"type":"string","description":"Revision hash.","readOnly":true},"custom":{"$ref":"#/components/schemas/unknownservice-unknownmodule-JsonNode"},"publishState":{"type":"string","description":"Document share publication status.","enum":["SYNCED","PENDING","DRAFT"]},"translatableTexts":{"type":"array","description":"Multilingual labels.","items":{"$ref":"#/components/schemas/dms-shelf-ShelfTranslatableText"}},"etag":{"type":"string"}},"required":["availability"]},"unknownservice-unknownmodule-JsonNode":{"description":"Search dialog.","properties":{"empty":{"type":"boolean"},"array":{"type":"boolean"},"null":{"type":"boolean"},"object":{"type":"boolean"},"float":{"type":"boolean"},"missingNode":{"type":"boolean"},"valueNode":{"type":"boolean"},"container":{"type":"boolean"},"integralNumber":{"type":"boolean"},"binary":{"type":"boolean"},"nodeType":{"type":"string","enum":["ARRAY","BINARY","BOOLEAN","MISSING","NULL","NUMBER","OBJECT","POJO","STRING"]},"string":{"type":"boolean"},"pojo":{"type":"boolean"},"short":{"type":"boolean"},"int":{"type":"boolean"},"long":{"type":"boolean"},"double":{"type":"boolean"},"bigDecimal":{"type":"boolean"},"bigInteger":{"type":"boolean"},"textual":{"type":"boolean","deprecated":true},"boolean":{"type":"boolean"},"floatingPointNumber":{"type":"boolean"},"number":{"type":"boolean"},"embeddedValue":{"type":"boolean"}}},"dms-shelf-ShelfTranslatableText":{"description":"Multilingual labels.","properties":{"version":{"type":"string","description":"Version Identifier for this Object (for PUT)"},"info":{"$ref":"#/components/schemas/core-api-MetaInfo"},"id":{"type":"string","description":"Unique identifier of the Object"},"alternativeText":{"type":"string","description":"Alternative text.","maxLength":2147483647,"minLength":0},"metaTitle":{"type":"string","description":"Meta title.","maxLength":255,"minLength":0},"languageCode":{"type":"string","description":"Language.","minLength":1}},"required":["languageCode"]},"common-tag-TagDto":{"description":"List of tags","properties":{"version":{"type":"string","description":"Version Identifier for this Object (for PUT)"},"info":{"$ref":"#/components/schemas/core-api-MetaInfo"},"id":{"type":"string","description":"Unique identifier of the Object"},"type":{"type":"string","description":"Tag types.","enum":["COMMON","ACCOUNT","PRODUCT","ASSET","DOCUMENT","OPEN_ITEM","CRM_COMMON","CRM_TASK","CRM_DEAL","CRM_PROJECT","DMS_SHELF_DOCUMENT"]},"label":{"type":"string","description":"Tag label."},"color":{"type":"string","description":"Color for displaying the tag."},"editColor":{"type":"string","description":"Color in the management UI."},"searchColor":{"type":"string","description":"Color in the search UI."},"tagGroup":{"$ref":"#/components/schemas/core-api-ApiCreatableReference"}},"required":["label","type"]},"core-api-ApiCreatableReference":{"description":"Relation type","properties":{"id":{"type":"string","description":"Identifier"},"label":{"type":"string","description":"a label"},"description":{"type":"string","description":"a short description","readOnly":true}}},"dms-shelf-ShelfDocumentType":{"description":"Document type.","properties":{"version":{"type":"string","description":"Version Identifier for this Object (for PUT)"},"info":{"$ref":"#/components/schemas/core-api-MetaInfo"},"id":{"type":"string","description":"Unique identifier of the Object"},"key":{"type":"string","description":"unique key of type","readOnly":true},"label":{"type":"string","description":"label of type","minLength":1},"systemPresetting":{"type":"boolean","default":false,"description":"system presetting","readOnly":true},"duration":{"type":"integer","format":"int32","description":"duration of storage (years)"},"revisionStorageRule":{"type":"integer","format":"int32","description":"storage rule for revisions"},"accessLevelRead":{"type":"integer","format":"int32","description":"Access level for reading."},"accessLevelWrite":{"type":"integer","format":"int32","description":"access level for writing"},"accessLevelDelete":{"type":"integer","format":"int32","description":"access level for deleting"},"active":{"type":"boolean","default":true,"description":"Is the document type active?"}},"required":["label"]},"dms-shelf-ShelfDocumentAttribution":{"properties":{"version":{"type":"string","description":"Version Identifier for this Object (for PUT)"},"info":{"$ref":"#/components/schemas/core-api-MetaInfo"},"id":{"type":"string","description":"Unique identifier of the Object"},"refType":{"type":"string","description":"type of the referenced object"},"refId":{"type":"integer","format":"int64","description":"id of the referenced object"},"uiSort":{"type":"integer","format":"int32","description":"Field managed by the UI."},"uiComment":{"type":"string","description":"Field managed by the UI."},"uiFavorite":{"type":"boolean","default":false,"description":"Field managed by the UI."},"mainAttribution":{"type":"boolean","description":"Main DMS resource link.","readOnly":true},"transformationKeys":{"type":"array","description":"Available image transformations.","items":{"type":"string","description":"Available image transformations."},"readOnly":true},"shelfResourceId":{"type":"integer","format":"int64","description":"Linked DMS resource identifier."},"publish":{"type":"boolean","description":"Should the document be published?"},"purpose":{"type":"string","description":"Relation type or purpose."}},"required":["purpose"]},"dms-shelf-ShelfImageTransformation":{"properties":{"version":{"type":"string","description":"Version Identifier for this Object (for PUT)"},"info":{"$ref":"#/components/schemas/core-api-MetaInfo"},"id":{"type":"string","description":"Unique identifier of the Object"},"uiKey":{"type":"string","description":"For distinguishing different transformations."},"share":{"$ref":"#/components/schemas/dms-shelf-ShelfShare"},"sizeX":{"type":"integer","format":"int32","description":"Width in pixels."},"sizeY":{"type":"integer","format":"int32","description":"Height in pixels."},"rotation":{"type":"integer","format":"int32","description":"Rotation in degrees."},"watermarkLabel":{"type":"string","description":"Watermark."},"imageFileStorageHandle":{"type":"string","description":"Internal reference to the physical file.","readOnly":true},"imageFileCreatedAt":{"type":"string","format":"date","description":"When the physical file was created.","readOnly":true},"imageFileDuration":{"type":"integer","format":"int32","description":"For how many days this physical file is kept (0 means unlimited)."}}},"core-error-ApiError":{"properties":{"instance":{"type":"string","description":"the resource that produced the error","readOnly":true},"trackingId":{"type":"string","description":"Internal tracking number for this Error","readOnly":true},"timeOfOccurence":{"type":"string","format":"date-time","description":"Internal timestamp, when this error happened","readOnly":true},"errors":{"$ref":"#/components/schemas/core-error-ApiError.Errors"},"decisions":{"type":"array","description":"all decisions, we need to take care of","items":{"$ref":"#/components/schemas/core-error-ApiErrorDecision"},"readOnly":true,"uniqueItems":true},"httpStatus":{"type":"integer","format":"int32","description":"HTTP-Status code"},"debug-info-url":{"type":"string","format":"uri","description":"optional url to get a more detailed stack trace","readOnly":true}},"required":["decisions","errors","instance","timeOfOccurence","trackingId"]},"core-error-ApiError.Errors":{"description":"all occured errors","properties":{"fieldErrors":{"type":"object","additionalProperties":{"type":"array","description":"One or more validation errors","items":{"$ref":"#/components/schemas/core-error-ApiErrorDetail"},"readOnly":true,"uniqueItems":true},"description":"One or more validation errors","readOnly":true},"services":{"type":"array","description":"One or more generel service errors","items":{"$ref":"#/components/schemas/core-error-ApiErrorDetail"},"readOnly":true,"uniqueItems":true}},"readOnly":true,"required":["fieldErrors","services"]},"core-error-ApiErrorDetail":{"description":"One or more generel service errors","properties":{"message":{"$ref":"#/components/schemas/core-api-LocalizeableMessage"},"property":{"type":"string","description":"property that has a constraint violation  (optional)"}},"readOnly":true},"core-api-LocalizeableMessage":{"description":"localizeable message","properties":{"messageCode":{"type":"string","description":"Internal unique identifier/key for this message"},"messageParameters":{"type":"object","additionalProperties":{"type":"object","description":"list of parameters to fill a formattable message"},"description":"list of parameters to fill a formattable message"},"formattedMessage":{"type":"string","description":"formatted message (default language)"}}},"core-error-ApiErrorDecision":{"description":"all decisions, we need to take care of","properties":{"message":{"$ref":"#/components/schemas/core-api-LocalizeableMessage"},"title":{"$ref":"#/components/schemas/core-api-LocalizeableMessage"},"multipleAnswersAllowed":{"type":"boolean","default":false,"description":"true, if an array of answers is required","readOnly":true},"textInput":{"type":"boolean","default":false,"description":"true, if text input instead of decisions is required","readOnly":true},"options":{"type":"array","description":"possible options for this decision","items":{"$ref":"#/components/schemas/core-error-ApiErrorDecision.DecisionOption"},"readOnly":true},"answerProperty":{"type":"string","description":"property to fill the decision into","readOnly":true},"answerPropertyType":{"type":"string","description":"type of the target property","enum":["FIELD","PARAMETER"],"readOnly":true},"searchDialog":{"$ref":"#/components/schemas/unknownservice-unknownmodule-JsonNode"}},"readOnly":true},"core-error-ApiErrorDecision.DecisionOption":{"description":"possible options for this decision","properties":{"message":{"$ref":"#/components/schemas/core-api-LocalizeableMessage"},"value":{"type":"string","description":"value for this decision","readOnly":true},"defaultOption":{"type":"boolean","default":false,"description":"default option","readOnly":true},"searchDialogs":{"type":"array","description":"Search dialogs to use.","items":{"$ref":"#/components/schemas/core-error-ApiErrorDecision.DecisionOptionSearchDialog"},"readOnly":true}}},"core-error-ApiErrorDecision.DecisionOptionSearchDialog":{"description":"Search dialogs to use.","properties":{"dialog":{"$ref":"#/components/schemas/unknownservice-unknownmodule-JsonNode"},"answerKey":{"type":"string","description":"Key for the search dialog result.","readOnly":true}}}}}}
```

## GET /dms/resources/{id}/shares

> get all existing shares

```json
{"openapi":"3.1.0","info":{"title":"OpenAPI definition","version":"2026.42.0"},"tags":[{"name":"Documents","description":"Resource managing the Documents in our DMS(Shelf)"}],"servers":[{"url":"api.example.com"}],"paths":{"/dms/resources/{id}/shares":{"get":{"tags":["Documents"],"summary":"get all existing shares","operationId":"getShare","parameters":[{"name":"id","in":"path","description":"an identifier","required":true,"schema":{"type":"integer","format":"int64"}}],"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/dms-shelf-ShelfShare"}}}}}}}}},"components":{"schemas":{"dms-shelf-ShelfShare":{"description":"Share information.","properties":{"version":{"type":"string","description":"Version Identifier for this Object (for PUT)"},"info":{"$ref":"#/components/schemas/core-api-MetaInfo"},"id":{"type":"string","description":"Unique identifier of the Object"},"publicUrlPath":{"type":"string","description":"URL path segment that gives public access to this resource.","readOnly":true},"publicUrlCreatedAt":{"type":"string","format":"date","description":"When the public resource was created.","readOnly":true},"publicUrlDurationInMinutes":{"type":"integer","format":"int64","description":"For how many minutes this resource path stays accessible (null means unlimited).","minimum":0},"availability":{"type":"string","description":"Determines how often a public URL is available.","enum":["UNLIMITED","ONE_TIME_USE"]},"timesUsed":{"type":"integer","format":"int32","description":"Number of uses.","readOnly":true},"appId":{"type":"string","format":"uuid","description":"App identifier."},"sharedByExternalRef":{"type":"string","description":"External reference to this share."},"revision":{"type":"integer","format":"int32","description":"Revision","readOnly":true},"eTag":{"type":"string","description":"Revision hash.","readOnly":true},"custom":{"$ref":"#/components/schemas/unknownservice-unknownmodule-JsonNode"},"publishState":{"type":"string","description":"Document share publication status.","enum":["SYNCED","PENDING","DRAFT"]},"translatableTexts":{"type":"array","description":"Multilingual labels.","items":{"$ref":"#/components/schemas/dms-shelf-ShelfTranslatableText"}},"etag":{"type":"string"}},"required":["availability"]},"core-api-MetaInfo":{"description":"MetaInformations for this Object","properties":{"createdAt":{"type":"string","format":"date-time","description":"Created At Timestamp","readOnly":true},"createdFrom":{"type":"string","description":"TenantUser-Identifier of the creator","readOnly":true},"updatedAt":{"type":"string","format":"date-time","description":"Last Updated AT Timestamp","readOnly":true},"updatedFrom":{"type":"string","description":"TenantUser-Identifier of most recent updater","readOnly":true}}},"unknownservice-unknownmodule-JsonNode":{"description":"Search dialog.","properties":{"empty":{"type":"boolean"},"array":{"type":"boolean"},"null":{"type":"boolean"},"object":{"type":"boolean"},"float":{"type":"boolean"},"missingNode":{"type":"boolean"},"valueNode":{"type":"boolean"},"container":{"type":"boolean"},"integralNumber":{"type":"boolean"},"binary":{"type":"boolean"},"nodeType":{"type":"string","enum":["ARRAY","BINARY","BOOLEAN","MISSING","NULL","NUMBER","OBJECT","POJO","STRING"]},"string":{"type":"boolean"},"pojo":{"type":"boolean"},"short":{"type":"boolean"},"int":{"type":"boolean"},"long":{"type":"boolean"},"double":{"type":"boolean"},"bigDecimal":{"type":"boolean"},"bigInteger":{"type":"boolean"},"textual":{"type":"boolean","deprecated":true},"boolean":{"type":"boolean"},"floatingPointNumber":{"type":"boolean"},"number":{"type":"boolean"},"embeddedValue":{"type":"boolean"}}},"dms-shelf-ShelfTranslatableText":{"description":"Multilingual labels.","properties":{"version":{"type":"string","description":"Version Identifier for this Object (for PUT)"},"info":{"$ref":"#/components/schemas/core-api-MetaInfo"},"id":{"type":"string","description":"Unique identifier of the Object"},"alternativeText":{"type":"string","description":"Alternative text.","maxLength":2147483647,"minLength":0},"metaTitle":{"type":"string","description":"Meta title.","maxLength":255,"minLength":0},"languageCode":{"type":"string","description":"Language.","minLength":1}},"required":["languageCode"]}}}}
```

## POST /dms/resources/{id}/shares

> Create new Share

```json
{"openapi":"3.1.0","info":{"title":"OpenAPI definition","version":"2026.42.0"},"tags":[{"name":"Documents","description":"Resource managing the Documents in our DMS(Shelf)"}],"servers":[{"url":"api.example.com"}],"paths":{"/dms/resources/{id}/shares":{"post":{"tags":["Documents"],"summary":"Create new Share","operationId":"createShare","parameters":[{"name":"id","in":"path","description":"an identifier","required":true,"schema":{"type":"integer","format":"int64"}}],"requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/dms-shelf-ShelfShare"}}},"required":true},"responses":{"200":{"description":"successful operation","content":{"application/json":{"schema":{"$ref":"#/components/schemas/dms-shelf-ShelfShare"}}}},"422":{"description":"Resource was not valid to process","content":{"application/json":{"schema":{"$ref":"#/components/schemas/core-error-ApiError"}}}}}}}},"components":{"schemas":{"dms-shelf-ShelfShare":{"description":"Share information.","properties":{"version":{"type":"string","description":"Version Identifier for this Object (for PUT)"},"info":{"$ref":"#/components/schemas/core-api-MetaInfo"},"id":{"type":"string","description":"Unique identifier of the Object"},"publicUrlPath":{"type":"string","description":"URL path segment that gives public access to this resource.","readOnly":true},"publicUrlCreatedAt":{"type":"string","format":"date","description":"When the public resource was created.","readOnly":true},"publicUrlDurationInMinutes":{"type":"integer","format":"int64","description":"For how many minutes this resource path stays accessible (null means unlimited).","minimum":0},"availability":{"type":"string","description":"Determines how often a public URL is available.","enum":["UNLIMITED","ONE_TIME_USE"]},"timesUsed":{"type":"integer","format":"int32","description":"Number of uses.","readOnly":true},"appId":{"type":"string","format":"uuid","description":"App identifier."},"sharedByExternalRef":{"type":"string","description":"External reference to this share."},"revision":{"type":"integer","format":"int32","description":"Revision","readOnly":true},"eTag":{"type":"string","description":"Revision hash.","readOnly":true},"custom":{"$ref":"#/components/schemas/unknownservice-unknownmodule-JsonNode"},"publishState":{"type":"string","description":"Document share publication status.","enum":["SYNCED","PENDING","DRAFT"]},"translatableTexts":{"type":"array","description":"Multilingual labels.","items":{"$ref":"#/components/schemas/dms-shelf-ShelfTranslatableText"}},"etag":{"type":"string"}},"required":["availability"]},"core-api-MetaInfo":{"description":"MetaInformations for this Object","properties":{"createdAt":{"type":"string","format":"date-time","description":"Created At Timestamp","readOnly":true},"createdFrom":{"type":"string","description":"TenantUser-Identifier of the creator","readOnly":true},"updatedAt":{"type":"string","format":"date-time","description":"Last Updated AT Timestamp","readOnly":true},"updatedFrom":{"type":"string","description":"TenantUser-Identifier of most recent updater","readOnly":true}}},"unknownservice-unknownmodule-JsonNode":{"description":"Search dialog.","properties":{"empty":{"type":"boolean"},"array":{"type":"boolean"},"null":{"type":"boolean"},"object":{"type":"boolean"},"float":{"type":"boolean"},"missingNode":{"type":"boolean"},"valueNode":{"type":"boolean"},"container":{"type":"boolean"},"integralNumber":{"type":"boolean"},"binary":{"type":"boolean"},"nodeType":{"type":"string","enum":["ARRAY","BINARY","BOOLEAN","MISSING","NULL","NUMBER","OBJECT","POJO","STRING"]},"string":{"type":"boolean"},"pojo":{"type":"boolean"},"short":{"type":"boolean"},"int":{"type":"boolean"},"long":{"type":"boolean"},"double":{"type":"boolean"},"bigDecimal":{"type":"boolean"},"bigInteger":{"type":"boolean"},"textual":{"type":"boolean","deprecated":true},"boolean":{"type":"boolean"},"floatingPointNumber":{"type":"boolean"},"number":{"type":"boolean"},"embeddedValue":{"type":"boolean"}}},"dms-shelf-ShelfTranslatableText":{"description":"Multilingual labels.","properties":{"version":{"type":"string","description":"Version Identifier for this Object (for PUT)"},"info":{"$ref":"#/components/schemas/core-api-MetaInfo"},"id":{"type":"string","description":"Unique identifier of the Object"},"alternativeText":{"type":"string","description":"Alternative text.","maxLength":2147483647,"minLength":0},"metaTitle":{"type":"string","description":"Meta title.","maxLength":255,"minLength":0},"languageCode":{"type":"string","description":"Language.","minLength":1}},"required":["languageCode"]},"core-error-ApiError":{"properties":{"instance":{"type":"string","description":"the resource that produced the error","readOnly":true},"trackingId":{"type":"string","description":"Internal tracking number for this Error","readOnly":true},"timeOfOccurence":{"type":"string","format":"date-time","description":"Internal timestamp, when this error happened","readOnly":true},"errors":{"$ref":"#/components/schemas/core-error-ApiError.Errors"},"decisions":{"type":"array","description":"all decisions, we need to take care of","items":{"$ref":"#/components/schemas/core-error-ApiErrorDecision"},"readOnly":true,"uniqueItems":true},"httpStatus":{"type":"integer","format":"int32","description":"HTTP-Status code"},"debug-info-url":{"type":"string","format":"uri","description":"optional url to get a more detailed stack trace","readOnly":true}},"required":["decisions","errors","instance","timeOfOccurence","trackingId"]},"core-error-ApiError.Errors":{"description":"all occured errors","properties":{"fieldErrors":{"type":"object","additionalProperties":{"type":"array","description":"One or more validation errors","items":{"$ref":"#/components/schemas/core-error-ApiErrorDetail"},"readOnly":true,"uniqueItems":true},"description":"One or more validation errors","readOnly":true},"services":{"type":"array","description":"One or more generel service errors","items":{"$ref":"#/components/schemas/core-error-ApiErrorDetail"},"readOnly":true,"uniqueItems":true}},"readOnly":true,"required":["fieldErrors","services"]},"core-error-ApiErrorDetail":{"description":"One or more generel service errors","properties":{"message":{"$ref":"#/components/schemas/core-api-LocalizeableMessage"},"property":{"type":"string","description":"property that has a constraint violation  (optional)"}},"readOnly":true},"core-api-LocalizeableMessage":{"description":"localizeable message","properties":{"messageCode":{"type":"string","description":"Internal unique identifier/key for this message"},"messageParameters":{"type":"object","additionalProperties":{"type":"object","description":"list of parameters to fill a formattable message"},"description":"list of parameters to fill a formattable message"},"formattedMessage":{"type":"string","description":"formatted message (default language)"}}},"core-error-ApiErrorDecision":{"description":"all decisions, we need to take care of","properties":{"message":{"$ref":"#/components/schemas/core-api-LocalizeableMessage"},"title":{"$ref":"#/components/schemas/core-api-LocalizeableMessage"},"multipleAnswersAllowed":{"type":"boolean","default":false,"description":"true, if an array of answers is required","readOnly":true},"textInput":{"type":"boolean","default":false,"description":"true, if text input instead of decisions is required","readOnly":true},"options":{"type":"array","description":"possible options for this decision","items":{"$ref":"#/components/schemas/core-error-ApiErrorDecision.DecisionOption"},"readOnly":true},"answerProperty":{"type":"string","description":"property to fill the decision into","readOnly":true},"answerPropertyType":{"type":"string","description":"type of the target property","enum":["FIELD","PARAMETER"],"readOnly":true},"searchDialog":{"$ref":"#/components/schemas/unknownservice-unknownmodule-JsonNode"}},"readOnly":true},"core-error-ApiErrorDecision.DecisionOption":{"description":"possible options for this decision","properties":{"message":{"$ref":"#/components/schemas/core-api-LocalizeableMessage"},"value":{"type":"string","description":"value for this decision","readOnly":true},"defaultOption":{"type":"boolean","default":false,"description":"default option","readOnly":true},"searchDialogs":{"type":"array","description":"Search dialogs to use.","items":{"$ref":"#/components/schemas/core-error-ApiErrorDecision.DecisionOptionSearchDialog"},"readOnly":true}}},"core-error-ApiErrorDecision.DecisionOptionSearchDialog":{"description":"Search dialogs to use.","properties":{"dialog":{"$ref":"#/components/schemas/unknownservice-unknownmodule-JsonNode"},"answerKey":{"type":"string","description":"Key for the search dialog result.","readOnly":true}}}}}}
```

## GET /dms/resources/{id}/file

> download the original or transformed document file

```json
{"openapi":"3.1.0","info":{"title":"OpenAPI definition","version":"2026.42.0"},"tags":[{"name":"Documents","description":"Resource managing the Documents in our DMS(Shelf)"}],"servers":[{"url":"api.example.com"}],"paths":{"/dms/resources/{id}/file":{"get":{"tags":["Documents"],"summary":"download the original or transformed document file","operationId":"handleFileDownload","parameters":[{"name":"id","in":"path","description":"DMS resource identifier.","required":true,"schema":{"type":"integer","format":"int64"}},{"name":"uiKey","in":"query","description":"Optional: restriction to a specific transformation.","required":false,"schema":{"type":"string"}},{"name":"disposition","in":"query","description":"Optional: requested content disposition from the request.","required":false,"schema":{"type":"string"}},{"name":"If-None-Match","in":"header","required":false,"schema":{"type":"string"}}],"responses":{"200":{"description":"Response contains File","content":{"application/json":{"schema":{"type":"object"}}}},"201":{"description":"Response with download-url","content":{"application/json":{"schema":{"type":"object"}}}},"303":{"description":"Location attribute contains alternate download location","content":{"application/json":{"schema":{"type":"object"}}}},"422":{"description":"Resource was not valid to process","content":{"application/json":{"schema":{"$ref":"#/components/schemas/core-error-ApiError"}}}}}}}},"components":{"schemas":{"core-error-ApiError":{"properties":{"instance":{"type":"string","description":"the resource that produced the error","readOnly":true},"trackingId":{"type":"string","description":"Internal tracking number for this Error","readOnly":true},"timeOfOccurence":{"type":"string","format":"date-time","description":"Internal timestamp, when this error happened","readOnly":true},"errors":{"$ref":"#/components/schemas/core-error-ApiError.Errors"},"decisions":{"type":"array","description":"all decisions, we need to take care of","items":{"$ref":"#/components/schemas/core-error-ApiErrorDecision"},"readOnly":true,"uniqueItems":true},"httpStatus":{"type":"integer","format":"int32","description":"HTTP-Status code"},"debug-info-url":{"type":"string","format":"uri","description":"optional url to get a more detailed stack trace","readOnly":true}},"required":["decisions","errors","instance","timeOfOccurence","trackingId"]},"core-error-ApiError.Errors":{"description":"all occured errors","properties":{"fieldErrors":{"type":"object","additionalProperties":{"type":"array","description":"One or more validation errors","items":{"$ref":"#/components/schemas/core-error-ApiErrorDetail"},"readOnly":true,"uniqueItems":true},"description":"One or more validation errors","readOnly":true},"services":{"type":"array","description":"One or more generel service errors","items":{"$ref":"#/components/schemas/core-error-ApiErrorDetail"},"readOnly":true,"uniqueItems":true}},"readOnly":true,"required":["fieldErrors","services"]},"core-error-ApiErrorDetail":{"description":"One or more generel service errors","properties":{"message":{"$ref":"#/components/schemas/core-api-LocalizeableMessage"},"property":{"type":"string","description":"property that has a constraint violation  (optional)"}},"readOnly":true},"core-api-LocalizeableMessage":{"description":"localizeable message","properties":{"messageCode":{"type":"string","description":"Internal unique identifier/key for this message"},"messageParameters":{"type":"object","additionalProperties":{"type":"object","description":"list of parameters to fill a formattable message"},"description":"list of parameters to fill a formattable message"},"formattedMessage":{"type":"string","description":"formatted message (default language)"}}},"core-error-ApiErrorDecision":{"description":"all decisions, we need to take care of","properties":{"message":{"$ref":"#/components/schemas/core-api-LocalizeableMessage"},"title":{"$ref":"#/components/schemas/core-api-LocalizeableMessage"},"multipleAnswersAllowed":{"type":"boolean","default":false,"description":"true, if an array of answers is required","readOnly":true},"textInput":{"type":"boolean","default":false,"description":"true, if text input instead of decisions is required","readOnly":true},"options":{"type":"array","description":"possible options for this decision","items":{"$ref":"#/components/schemas/core-error-ApiErrorDecision.DecisionOption"},"readOnly":true},"answerProperty":{"type":"string","description":"property to fill the decision into","readOnly":true},"answerPropertyType":{"type":"string","description":"type of the target property","enum":["FIELD","PARAMETER"],"readOnly":true},"searchDialog":{"$ref":"#/components/schemas/unknownservice-unknownmodule-JsonNode"}},"readOnly":true},"core-error-ApiErrorDecision.DecisionOption":{"description":"possible options for this decision","properties":{"message":{"$ref":"#/components/schemas/core-api-LocalizeableMessage"},"value":{"type":"string","description":"value for this decision","readOnly":true},"defaultOption":{"type":"boolean","default":false,"description":"default option","readOnly":true},"searchDialogs":{"type":"array","description":"Search dialogs to use.","items":{"$ref":"#/components/schemas/core-error-ApiErrorDecision.DecisionOptionSearchDialog"},"readOnly":true}}},"core-error-ApiErrorDecision.DecisionOptionSearchDialog":{"description":"Search dialogs to use.","properties":{"dialog":{"$ref":"#/components/schemas/unknownservice-unknownmodule-JsonNode"},"answerKey":{"type":"string","description":"Key for the search dialog result.","readOnly":true}}},"unknownservice-unknownmodule-JsonNode":{"description":"Search dialog.","properties":{"empty":{"type":"boolean"},"array":{"type":"boolean"},"null":{"type":"boolean"},"object":{"type":"boolean"},"float":{"type":"boolean"},"missingNode":{"type":"boolean"},"valueNode":{"type":"boolean"},"container":{"type":"boolean"},"integralNumber":{"type":"boolean"},"binary":{"type":"boolean"},"nodeType":{"type":"string","enum":["ARRAY","BINARY","BOOLEAN","MISSING","NULL","NUMBER","OBJECT","POJO","STRING"]},"string":{"type":"boolean"},"pojo":{"type":"boolean"},"short":{"type":"boolean"},"int":{"type":"boolean"},"long":{"type":"boolean"},"double":{"type":"boolean"},"bigDecimal":{"type":"boolean"},"bigInteger":{"type":"boolean"},"textual":{"type":"boolean","deprecated":true},"boolean":{"type":"boolean"},"floatingPointNumber":{"type":"boolean"},"number":{"type":"boolean"},"embeddedValue":{"type":"boolean"}}}}}}
```

## POST /dms/resources/{id}/file

> upload/change the original document file

```json
{"openapi":"3.1.0","info":{"title":"OpenAPI definition","version":"2026.42.0"},"tags":[{"name":"Documents","description":"Resource managing the Documents in our DMS(Shelf)"}],"servers":[{"url":"api.example.com"}],"paths":{"/dms/resources/{id}/file":{"post":{"tags":["Documents"],"summary":"upload/change the original document file","operationId":"handleFileUpload","parameters":[{"name":"id","in":"path","description":"an identifier","required":true,"schema":{"type":"integer","format":"int64"}},{"name":"sha256hash","in":"query","required":false,"schema":{"type":"string"}}],"requestBody":{"content":{"multipart/form-data":{"schema":{"type":"object","properties":{"file":{"type":"string","format":"binary"}},"required":["file"]}}}},"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"$ref":"#/components/schemas/core-api-OperationMessage"}}}}}}}},"components":{"schemas":{"core-api-OperationMessage":{"properties":{"context":{"type":"string","description":"message context"},"messageValue":{"type":"string","description":" message"}}}}}}
```

## POST /dms/resources/{id}/file-transfer

> start a file transfer (chunked and multiparted)

```json
{"openapi":"3.1.0","info":{"title":"OpenAPI definition","version":"2026.42.0"},"tags":[{"name":"Documents","description":"Resource managing the Documents in our DMS(Shelf)"}],"servers":[{"url":"api.example.com"}],"paths":{"/dms/resources/{id}/file-transfer":{"post":{"tags":["Documents"],"summary":"start a file transfer (chunked and multiparted)","operationId":"createFileTransfer","parameters":[{"name":"id","in":"path","description":"an identifier","required":true,"schema":{"type":"integer","format":"int64"}}],"requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/dms-shelf-TransferFileCreateRequest"}}},"required":true},"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"$ref":"#/components/schemas/dms-shelf-TransferFileCreateResponse"}}}}}}}},"components":{"schemas":{"dms-shelf-TransferFileCreateRequest":{"properties":{"fileName":{"type":"string","description":"Full target file name."}},"required":["fileName"]},"dms-shelf-TransferFileCreateResponse":{"properties":{"token":{"type":"string","description":"Token for the file transfer."}}}}}}
```

## POST /dms/resources/{id}/file-transfer/{token}/terminate

> terminate/delete a file transfer

```json
{"openapi":"3.1.0","info":{"title":"OpenAPI definition","version":"2026.42.0"},"tags":[{"name":"Documents","description":"Resource managing the Documents in our DMS(Shelf)"}],"servers":[{"url":"api.example.com"}],"paths":{"/dms/resources/{id}/file-transfer/{token}/terminate":{"post":{"tags":["Documents"],"summary":"terminate/delete a file transfer","operationId":"terminateFileTransfer","parameters":[{"name":"id","in":"path","description":"an identifier","required":true,"schema":{"type":"integer","format":"int64"}},{"name":"token","in":"path","description":"file-transfer token","required":true,"schema":{"type":"string"}}],"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"type":"object"}}}}}}}}}
```

## POST /dms/resources/{id}/file-transfer/{token}/finish

> Finish a file transfer

```json
{"openapi":"3.1.0","info":{"title":"OpenAPI definition","version":"2026.42.0"},"tags":[{"name":"Documents","description":"Resource managing the Documents in our DMS(Shelf)"}],"servers":[{"url":"api.example.com"}],"paths":{"/dms/resources/{id}/file-transfer/{token}/finish":{"post":{"tags":["Documents"],"summary":"Finish a file transfer","operationId":"finishFileTransfer","parameters":[{"name":"id","in":"path","description":"an identifier","required":true,"schema":{"type":"integer","format":"int64"}},{"name":"token","in":"path","description":"file-transfer token","required":true,"schema":{"type":"string"}}],"requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/dms-shelf-TransferFileFinishRequest"}}},"required":true},"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"type":"object"}}}}}}}},"components":{"schemas":{"dms-shelf-TransferFileFinishRequest":{"properties":{"partCount":{"type":"integer","format":"int64","description":"Number of parts that were uploaded.","minimum":0},"sha256Check":{"type":"string","description":"The sha256 checksum of the complete file (optional)."}},"required":["partCount"]}}}}
```

## POST /dms/resources/dms-key/{dmsKey}

>

```json
{"openapi":"3.1.0","info":{"title":"OpenAPI definition","version":"2026.42.0"},"tags":[{"name":"Documents","description":"Resource managing the Documents in our DMS(Shelf)"}],"servers":[{"url":"api.example.com"}],"paths":{"/dms/resources/dms-key/{dmsKey}":{"post":{"tags":["Documents"],"operationId":"createWithQuery","parameters":[{"name":"dmsKey","in":"path","required":true,"schema":{"type":"string"}}],"requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/dms-shelf-ShelfDocumentEntryResource.DmsUploadWrapper"}}},"required":true},"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"$ref":"#/components/schemas/dms-shelf-ShelfDocument"}}}}}}}},"components":{"schemas":{"dms-shelf-ShelfDocumentEntryResource.DmsUploadWrapper":{"properties":{"lookUps":{"type":"array","description":"Comparisons that are combined with AND.","items":{"$ref":"#/components/schemas/dms-shelf-ShelfDocumentEntryResource.DmsUploadLookup"}},"resource":{"$ref":"#/components/schemas/dms-shelf-ShelfDocument"},"purpose":{"type":"string"},"uiSort":{"type":"integer","format":"int32"}},"required":["lookUps","resource"]},"dms-shelf-ShelfDocumentEntryResource.DmsUploadLookup":{"description":"Comparisons that are combined with AND.","properties":{"field":{"type":"string","description":"CUnit path."},"value":{"type":"string","description":"Comparison value."}},"required":["field","value"]},"dms-shelf-ShelfDocument":{"properties":{"version":{"type":"string","description":"Version Identifier for this Object (for PUT)"},"info":{"$ref":"#/components/schemas/core-api-MetaInfo"},"id":{"type":"string","description":"Unique identifier of the Object"},"file":{"$ref":"#/components/schemas/dms-shelf-ShelfFile"},"shares":{"type":"array","description":"Share information.","items":{"$ref":"#/components/schemas/dms-shelf-ShelfShare"},"readOnly":true},"description":{"type":"string","description":"description of this document"},"entryDate":{"type":"string","format":"date","description":"Date of this Entry/Document"},"plannedRemovalDate":{"type":"string","format":"date","description":"Automatic deletion from.","readOnly":true},"custom":{"$ref":"#/components/schemas/unknownservice-unknownmodule-JsonNode"},"tags":{"type":"array","description":"List of tags","items":{"$ref":"#/components/schemas/common-tag-TagDto"}},"note":{"type":"string","description":"Note."},"externalId":{"type":"string","format":"uuid","description":"External identifier.","readOnly":true},"alias":{"type":"string","description":"Alias"},"type":{"$ref":"#/components/schemas/dms-shelf-ShelfDocumentType"},"state":{"type":"string","description":"Document status.","enum":["DRAFT","FILE_ATTACHED","MISSING"],"readOnly":true},"deletionState":{"type":"string","default":"NOT_YET","description":"Deletion status.","enum":["NOT_YET","PREPARE_DELETE","FILE_DELETED","MANUALLY_RETAIN"],"readOnly":true},"translatableTexts":{"type":"array","description":"Multilingual labels.","items":{"$ref":"#/components/schemas/dms-shelf-ShelfTranslatableText"}}},"required":["entryDate"]},"core-api-MetaInfo":{"description":"MetaInformations for this Object","properties":{"createdAt":{"type":"string","format":"date-time","description":"Created At Timestamp","readOnly":true},"createdFrom":{"type":"string","description":"TenantUser-Identifier of the creator","readOnly":true},"updatedAt":{"type":"string","format":"date-time","description":"Last Updated AT Timestamp","readOnly":true},"updatedFrom":{"type":"string","description":"TenantUser-Identifier of most recent updater","readOnly":true}}},"dms-shelf-ShelfFile":{"description":"file data","properties":{"version":{"type":"string","description":"Version Identifier for this Object (for PUT)"},"info":{"$ref":"#/components/schemas/core-api-MetaInfo"},"id":{"type":"string","description":"Unique identifier of the Object"},"publicFileExtension":{"type":"string","description":"file-extension of this entry","readOnly":true},"publicFileName":{"type":"string","description":"file-name (without extension) of this entry","readOnly":true},"storageHandle":{"type":"string","description":"current reference of this file in our storage ","readOnly":true},"contentType":{"type":"string","description":"detected content type","readOnly":true},"metaDataEntries":{"type":"array","description":"meta data","items":{"$ref":"#/components/schemas/dms-shelf-ShelfFileMetaData"},"readOnly":true},"fileSize":{"type":"integer","format":"int64","description":"fileSize","readOnly":true},"revisionNumber":{"type":"integer","format":"int32","description":"revision number of this file","readOnly":true},"subFiles":{"type":"array","description":"subFiles for this file","items":{"$ref":"#/components/schemas/dms-shelf-SubFileInfo"},"readOnly":true}}},"dms-shelf-ShelfFileMetaData":{"description":"meta data","properties":{"version":{"type":"string","description":"Version Identifier for this Object (for PUT)"},"info":{"$ref":"#/components/schemas/core-api-MetaInfo"},"id":{"type":"string","description":"Unique identifier of the Object"},"metaKey":{"type":"string","description":"Metadata key."},"metaValue":{"type":"string","description":"Metadata value."}},"required":["metaKey"]},"dms-shelf-SubFileInfo":{"description":"subFiles for this file","properties":{"version":{"type":"string","description":"Version Identifier for this Object (for PUT)"},"info":{"$ref":"#/components/schemas/core-api-MetaInfo"},"id":{"type":"string","description":"Unique identifier of the Object"},"name":{"type":"string","description":"fileName"},"parentPath":{"type":"string","description":"Parent-Path"},"fullPath":{"type":"string","description":"Full-Path"},"modifiedAt":{"type":"string","format":"date-time","description":"file last modified"},"contentType":{"type":"string","description":"Content type."},"shelfFile":{"$ref":"#/components/schemas/core-api-ApiObjectReference"}}},"core-api-ApiObjectReference":{"description":"Parent category.","properties":{"id":{"type":"string","description":"Identifier"},"label":{"type":"string","description":"a label","readOnly":true},"description":{"type":"string","description":"a short description","readOnly":true},"active":{"type":"boolean","description":"Active.","readOnly":true}},"required":["id"]},"dms-shelf-ShelfShare":{"description":"Share information.","properties":{"version":{"type":"string","description":"Version Identifier for this Object (for PUT)"},"info":{"$ref":"#/components/schemas/core-api-MetaInfo"},"id":{"type":"string","description":"Unique identifier of the Object"},"publicUrlPath":{"type":"string","description":"URL path segment that gives public access to this resource.","readOnly":true},"publicUrlCreatedAt":{"type":"string","format":"date","description":"When the public resource was created.","readOnly":true},"publicUrlDurationInMinutes":{"type":"integer","format":"int64","description":"For how many minutes this resource path stays accessible (null means unlimited).","minimum":0},"availability":{"type":"string","description":"Determines how often a public URL is available.","enum":["UNLIMITED","ONE_TIME_USE"]},"timesUsed":{"type":"integer","format":"int32","description":"Number of uses.","readOnly":true},"appId":{"type":"string","format":"uuid","description":"App identifier."},"sharedByExternalRef":{"type":"string","description":"External reference to this share."},"revision":{"type":"integer","format":"int32","description":"Revision","readOnly":true},"eTag":{"type":"string","description":"Revision hash.","readOnly":true},"custom":{"$ref":"#/components/schemas/unknownservice-unknownmodule-JsonNode"},"publishState":{"type":"string","description":"Document share publication status.","enum":["SYNCED","PENDING","DRAFT"]},"translatableTexts":{"type":"array","description":"Multilingual labels.","items":{"$ref":"#/components/schemas/dms-shelf-ShelfTranslatableText"}},"etag":{"type":"string"}},"required":["availability"]},"unknownservice-unknownmodule-JsonNode":{"description":"Search dialog.","properties":{"empty":{"type":"boolean"},"array":{"type":"boolean"},"null":{"type":"boolean"},"object":{"type":"boolean"},"float":{"type":"boolean"},"missingNode":{"type":"boolean"},"valueNode":{"type":"boolean"},"container":{"type":"boolean"},"integralNumber":{"type":"boolean"},"binary":{"type":"boolean"},"nodeType":{"type":"string","enum":["ARRAY","BINARY","BOOLEAN","MISSING","NULL","NUMBER","OBJECT","POJO","STRING"]},"string":{"type":"boolean"},"pojo":{"type":"boolean"},"short":{"type":"boolean"},"int":{"type":"boolean"},"long":{"type":"boolean
[...]
